package com.evasion.springsecurity;


import com.evasion.ejb.local.UserDetailsServiceLocal;
import java.io.Serializable;
import javax.ejb.EJB;
import org.springframework.dao.DataAccessException;
import org.springframework.security.userdetails.UserDetails;
import org.springframework.security.userdetails.UserDetailsService;
import org.springframework.security.userdetails.UsernameNotFoundException;

/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
/**
 *
 * @author sebastien.glon
 */
public class LoginSpring implements UserDetailsService, Serializable {

    @EJB
    UserDetailsServiceLocal userDetailsService;

    @Override
    public UserDetails loadUserByUsername(String username) throws UsernameNotFoundException, DataAccessException {
        try {
            UserDetails user = userDetailsService.loadUserByUsername(username);
            if (user == null) {
                throw new UsernameNotFoundException(username);
            }
            return user;
        }
        catch (Exception e) {
            throw new DataAccessException(username) {
            };
        }
    }

    public UserDetailsServiceLocal getUserDetailsService() {
        return userDetailsService;
    }

    public void setUserDetailsService(UserDetailsServiceLocal userDetailsService) {
        this.userDetailsService = userDetailsService;
    }
   
}
